---
title: Getting the bitmap of a voice filter
---
import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';


# Getting the bitmap of a voice filter

Each filter has an associated bitmap (an image) that represents it. 
That image is useful if you’re building a UI around the Control API and you want a graphical representation of each voice filter.

The following image showcases what a bitmap looks like.

<div class="doc-img-container">

![Voice filter Bitmaps](../img/voice-bitmaps-edited.png)

</div>

To get the bitmap for a particular voice filter, you’ll use the `getBitmap` command that looks like this:

```json
{
  "action": "getBitmap",
  "id": "[a unique id]",
  "payload": {
    "voiceID": "[the voice ID of your choice]"
  }
}
```

The API in return, will issue an event with the name of `getBitmap` , so make sure your client app is waiting for it.

The structure of the event looks like this:

```json
{
  "actionType": "getBitmap",
  "actionID": "[the unique ID you used in your message]",
  "appVersion": "2.0.0.34",
  "actionObject": {
    "result": {
      "default": "iVBORw0KUuxZaGehlmhmkW50Ng9dM [...] ==",
      "selected": "iVBORw0KUuxZaGehlmhmkW50Ng9dM [...] ==",
      "transparent": "iVBORw0KGgoAAAANSUhEUgAAAGwAAABsCAYAAACPZlfN[...] =="
    }
  }
}
```

Out of all that information, here is what you should know:

- `actionID`: This is the `id` you sent as part of the original `getBitmap` message. You can use this information to match the response to the correct voice, specially so if you’re requesting several at the same time.

<div class="doc-img-container">

![All three versions of each icon](../img/three-icon-versions.png)

</div>

- `actionObject.result.default`: The bitmap encoded information for the default icon for this voice filter. You have the GIF data of the image here encoded in base64, it’s up to you to display it based on the tech stack of your choice (usually the image has a white background).
- `actionObject.result.selected` : This is the bitmap to show when the filter has been selected (usually has a blue background).
- `actionObject.result.transparent` : The bitmap encoded information for the icon of this voice filter. This variation has a transparent background.

You can see the following code sample to show you how to use the encoded bitmap information to display the image:

<Tabs>
<TabItem value="javascript" label="JavaScript">

```javascript

document.querySelector(".your-voice-icon-container img").setAttribute('src', 'data:image/gif;base64,'+actionObject.result.default);

// Get the element
const imgElement = document.querySelector(".your-voice-icon-container img");

// Set the initial image source to the "default image"
imgElement.setAttribute('src', 'data:image/gif;base64,' + actionObject.result.default);
imgElement.setAttribute('data-image', 'default');

// Add a click event listener to the element
imgElement.addEventListener('click', function() {

  const currentImage = imgElement.getAttribute('data-image');

  if (currentImage == 'selected') {
     imgElement.setAttribute('src', 'data:image/gif;base64,' + actionObject.result.default);
     imgElement.setAtttribute('data-imge', 'default')
  } else {
     imgElement.setAttribute('src', 'data:image/gif;base64,' + actionObject.result.selected);
     imgElement.setAtttribute('data-imge', 'selected')
   }
});

```
</TabItem>
<TabItem value="py" label="Python">

```python
#Assuming Flask for this example, feel free to adapt to whatever framework you're using

from flask import render_template

# Define a route for the page
@app.route('/your-voice')
def your_voice():
    # Assume that actionObject.default and actionObject.selected contain base64-encoded image data
    default_image_data = actionObject.result.default
    selected_image_data = actionObject.result.selected

    # Render the template with the initial image source and "data-" attribute
    return render_template('your_voice.html', default_image_data=default_image_data, selected_image_data=selected_image_data)

# In your_voice.html template:
<div class="your-voice-icon-container">
    <img src="data:image/gif;base64,{{ default_image_data }}" data-image="default">
</div>

<!-- Include the JavaScript code in a script tag -->
<script>
    // Get the element
    const imgElement = document.querySelector(".your-voice-icon-container img");

    // Set the initial image source to the "default image"
    imgElement.setAttribute('src', 'data:image/gif;base64,' + '{{ default_image_data }}');
    imgElement.setAttribute('data-image', 'default');

    // Add a click event listener to the element
    imgElement.addEventListener('click', function() {
        const currentImage = imgElement.getAttribute('data-image');

        if (currentImage == 'selected') {
            imgElement.setAttribute('src', 'data:image/gif;base64,' + '{{ default_image_data }}');
            imgElement.setAttribute('data-image', 'default');
        } else {
            imgElement.setAttribute('src', 'data:image/gif;base64,' + '{{ selected_image_data }}');
            imgElement.setAttribute('data-image', 'selected');
        }
    });
</script>

```
</TabItem>

</Tabs>